/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2010
 *    David Martnez Oliveira
 *
 * This file is part of EDMA.
 *
 * EDMA is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EDMA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with EDMA.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
**************************************************
    Entorno de Desarrollo Modular y Abierto (EDMA)
    EDMA 0.5.1r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF Wizard Gnomized 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : PERSON_INNER
    Description : Simple person class to be used with the INNER approach
                  This class is used by the inheritance tests
    Author      : David martnez Oliveira
    Date        : March, 27th, 2002
-----------------------------------------------------
  REVISIONS :
***************************************************
*/
 
/*
***************************************************
  General Header Files
***************************************************
*/
 
#include <stdio.h>
#include <string.h>

/*
***************************************************
  EDMA Header Files
***************************************************
*/
 
#include <edma.h>

/*
***************************************************
  Private Data Struct for class PERSON_INNER
***************************************************
*/
 
typedef struct
  {
     EPChar		name;
}DtPERSON_INNER;
/*
***************************************************
  Method Declaration for class name
***************************************************
*/
 
ESint32 EDMAPROC
PERSON_INNERdisplay(OBJID IdObj)
{
  DtPERSON_INNER	*m;
  OBJID                 e;

  m = (DtPERSON_INNER *) edma_get_data_ref (IdObj);
  if (m->name == NULL)
    edma_wprop3 (IdObj, "name", "NoBody");

  /* Run INNER method within a try-catch so if an exception occurs
   * no error message is printed out.
   *
   * FIXME: We should check exception in order to find out if it is
   * due to non existing method or classpath*/
  
  EDMA_TRY 
    {
      edma_met3 (IdObj, "INNER<.display");
    }
  
  EDMA_CATCH(e) {}
    /*
    { 
      edma_printf_obj (IdObj, "Exception caught. Object: %ld", e);
      edma_met3 (e, "brief");
    }
  */
  EDMA_TRY_END;

  printf ("%s", m->name); 
  return 0;    
}



/********** END C IMPLEMENTATION SKELETON ******************/
